---
default:
  tags:
    - gitlab-org-docker

include:
  - project: "to-be-continuous/gitleaks"
    ref: 2.5.2
    file: "templates/gitlab-ci-gitleaks.yml"
  - project: 'renovate-bot/renovate-runner'
    ref: v20.1.0
    file: '/templates/renovate-config-validator.gitlab-ci.yml'
    rules:
      - if: $CI_PIPELINE_SOURCE == 'merge_request_event'
        changes:
          paths:
            - .gitlab-ci.yml
            - renovate.json
  - project: 'sylva-projects/sylva-elements/renovate'
    ref: 1.0.0
    file: '/templates/renovate-dry-run.gitlab-ci.yml'
    rules:
      - if: $CI_PIPELINE_SOURCE == 'merge_request_event'
        changes:
          paths:
            - renovate.json
  - project: 'sylva-projects/sylva-elements/ci-tooling/ci-templates'
    ref: 1.0.37
    file:
      - 'templates/docker-build.yml'
      - 'templates/release-notes.yml'

variables:
  SYLVA_CORE_BRANCH:
    value: main
    description: "Sylva-core branch to use for cross-repo pipeline"

pylama:
  stage: test
  needs: []
  interruptible: true
  image: python:3.13.2-slim
  script:
    - pip install setuptools
    - pip install pylama==8.4.1
    - pylama .
  rules:
    - if: $CI_PIPELINE_SOURCE == 'merge_request_event'
    - if: '$CI_PIPELINE_SOURCE == "pipeline"'

.docker-base:
  parallel:
    matrix:
      - DOCKER_FILE: ci-image/Dockerfile
        IMAGE_REGISTRY: $CI_REGISTRY_IMAGE
        # renovate: datasource=gitlab-tags depName=sylva-projects/sylva-elements/container-images/sylva-toolbox
        SYLVA_TOOLBOX_TAG: v0.8.0
        DOCKER_BUILD_ARGS: "--build-arg SYLVA_TOOLBOX_TAG=${SYLVA_TOOLBOX_TAG}"
      - DOCKER_FILE: ci-release-image/Dockerfile
        IMAGE_REGISTRY: $CI_REGISTRY_IMAGE/ci-release-image
      - DOCKER_FILE: ci-operator-image/Dockerfile
        IMAGE_REGISTRY: $CI_REGISTRY_IMAGE/ci-operator-image
      - DOCKER_FILE: ci-playwright-image/Dockerfile
        IMAGE_REGISTRY: $CI_REGISTRY_IMAGE/ci-playwright-image
      - DOCKER_FILE: ci-systemd-image/Dockerfile
        IMAGE_REGISTRY: $CI_REGISTRY_IMAGE/ci-systemd-image

# Cross repo pipeline is manual as only maintainers of Sylva-core can run it
sylva-core-cross-project:
  stage: test
  variables:
    CI_IMAGE: $CI_REGISTRY_IMAGE/snapshot:0.0.0-git-$CI_COMMIT_SHORT_SHA
    SYLVA_TOOLBOX_VERSION: $SYLVA_TOOLBOX_TAG
  trigger:
    project: sylva-projects/sylva-core
    branch: $SYLVA_CORE_BRANCH
    strategy: depend
  rules:
    - if: $CI_MERGE_REQUEST_LABELS =~ /renovate/
      when: manual
    - if: $CI_PIPELINE_SOURCE == 'merge_request_event'
      when: manual
    - if: $CI_PIPELINE_SOURCE == 'web'
      when: manual
  allow_failure: true
